<?php

namespace BitGoblin\MCST\Controllers;

use Pheanstalk\Pheanstalk;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;
use Slim\Views\Twig;

use BitGoblin\MCST\Minecraft\Server;

class HomeController extends Controller {

  public function getIndex(Request $request, Response $response, $args): Response {
    $config = $this->get('config');

    // find servers
    $minecraftDir = $config->get('server_directory');
    $serverDirs = glob($minecraftDir . "/*", GLOB_ONLYDIR);
    $minecraftServers = array();
    foreach ($serverDirs as $i => $m) {
      array_push($minecraftServers, new Server($m));
    }

    // create pheanstalk object and create a job
    $pheanstalk = Pheanstalk::create($config->get('beanstalkd.host'), $config->get('beanstalkd.port'));
    $pheanstalk
      ->useTube('mcst')
      ->put("refresh-server-downloads", Pheanstalk::DEFAULT_PRIORITY);

    $view = Twig::fromRequest($request);
    return $view->render($response, 'index.twig', [
      'servers' => $minecraftServers,
    ]);
  }

}
